## anbox 0.0~git20210106

=== CMakeLists.txt ===
project(anbox C CXX)
cmake_minimum_required(VERSION 2.8.2)

include(CTest)
include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wno-error=pedantic -Wno-variadic-macros -Wextra -fPIC")

# By default, all symbols are visible in the library. We strip out things we don't
# want at link time, by running a version script (see unity-scopes.map and the
# setting of LINK_FLAGS below).
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=default")

set(C_AND_CXX_WARNINGS "-pedantic -Wno-error=pedantic -Wall -Wextra")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wold-style-cast")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_AND_CXX_WARNINGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_WARNINGS}")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 ${C_AND_CXX_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_WARNINGS}")

# -fno-permissive causes warnings with clang, so we only enable it for gcc
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
  option(Werror "Treat warnings as errors" ON)
else()
  option(Werror "Treat warnings as errors" OFF)
endif()

if (${Werror})
    message(STATUS "Treat warnings as errors")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=deprecated-declarations")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
  endif()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Boost COMPONENTS filesystem log serialization system thread program_options)
find_package(PkgConfig)
find_package(Threads)
find_package(EGL REQUIRED)
find_package(GLESv2 REQUIRED)
find_package(Protobuf REQUIRED)

pkg_check_modules(SDL2 sdl2 REQUIRED)
pkg_check_modules(SDL2_IMAGE SDL2_image REQUIRED)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(LXC lxc REQUIRED)
pkg_check_modules(PROPERTIES_CPP properties-cpp REQUIRED)
pkg_check_modules(LIBSYSTEMD libsystemd REQUIRED)
pkg_check_modules(LIBCAP libcap REQUIRED)

message(STATUS "LXC version: ${LXC_VERSION}")
if (${LXC_VERSION} VERSION_LESS 3.0)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_LXC2_SUPPORT")
  message(STATUS "Building with LXC 2.x compatibility support")
endif()

option(ENABLE_X11 "Enable X11 support" ON)
if (ENABLE_X11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DX11_SUPPORT")
endif()

option(ENABLE_WAYLAND "Enable wayland support" ON)
if (ENABLE_WAYLAND)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWAYLAND_SUPPORT")
endif()

option(ENABLE_MIR "Enable mir support" OFF)
if (ENABLE_MIR)
  pkg_check_modules(MIRCLIENT mirclient REQUIRED)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMIR_SUPPORT")
endif()

if (NOT BINDERFS_PATH)
  set(BINDERFS_PATH "/dev/binderfs")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DEGL_NO_X11")

if((Protobuf_VERSION VERSION_GREATER "3.7") OR (Protobuf_VERSION VERSION_EQUAL "3.7"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DUSE_PROTOBUF_CALLBACK_HEADER")
endif()

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

find_package(GMock)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fPIC")


if (NOT ANBOX_VERSION)
    exec_program("git" ${CMAKE_SOURCE_DIR} ARGS "rev-parse --short HEAD" OUTPUT_VARIABLE GIT_COMMIT_HASH)
    set(ANBOX_VERSION "local-${GIT_COMMIT_HASH}")
endif()
if (ANBOX_VERSION_SUFFIX)
    set(ANBOX_VERSION "${ANBOX_VERSION}-${ANBOX_VERSION_SUFFIX}")
endif()
set(ANBOX_RESOURCE_DIR "${CMAKE_INSTALL_DATADIR}/anbox")
set(ANBOX_RESOURCE_DIR_FULL "${CMAKE_INSTALL_FULL_DATADIR}/anbox")
set(ANBOX_STATEDIR_FULL "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/anbox")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/anbox/build/config.h.in
               ${CMAKE_CURRENT_SOURCE_DIR}/src/anbox/build/config.h)

add_subdirectory(external)
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(android)

if (NOT "${HOST_CMAKE_C_COMPILER}" STREQUAL "")
  message(STATUS "Host C compiler: ${HOST_CMAKE_C_COMPILER}")
  message(STATUS "Host C compiler: ${HOST_CMAKE_CXX_COMPILER}")
endif()

option(SNAP_CONFINEMENT "Enable snap confinement support" OFF)
if (SNAP_CONFINEMENT)
  message(STATUS "Building with support for snap confinement")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_SNAP_CONFINEMENT")
endif()

install(FILES data/ui/loading-screen.png DESTINATION ${ANBOX_RESOURCE_DIR}/ui)

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== android/CMakeLists.txt ===
include_directories(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_BINARY_DIR}/src)

set(ANBOXD_SOURCES
    ${CMAKE_SOURCE_DIR}/src/anbox/rpc/message_processor.cpp
    ${CMAKE_SOURCE_DIR}/src/anbox/rpc/pending_call_cache.cpp
    ${CMAKE_SOURCE_DIR}/src/anbox/common/fd.cpp
    service/activity_manager_interface.cpp
    service/platform_service.cpp
    service/platform_service_interface.cpp
    service/platform_api_stub.cpp
    service/android_api_skeleton.cpp
    service/message_processor.cpp
    service/local_socket_connection.cpp
    service/host_connector.cpp
    service/daemon.cpp
    service/main.cpp)

add_executable(anboxd ${ANBOXD_SOURCES})
target_link_libraries(anboxd
    pthread
    process-cpp
    anbox-protobuf)

set(HWCOMPOSER_SOURCES
    hwcomposer/hwcomposer.cpp)

add_library(hwcomposer.anbox SHARED ${HWCOMPOSER_SOURCES})

set(AUDIO_SOURCES
    audio/audio_hw.cpp)
add_library(audio.goldfish SHARED ${AUDIO_SOURCES})

# As we're adding Android specific bits in this project we can't
# build this safely within default build anymore. We keep this
# for easy integration into used IDEs.
set_target_properties(anboxd
    PROPERTIES EXCLUDE_FROM_ALL 1 EXCLUDE_FROM_DEFAULT_BUILD 1)

set_target_properties(hwcomposer.anbox
    PROPERTIES EXCLUDE_FROM_ALL 1 EXCLUDE_FROM_DEFAULT_BUILD 1)

set_target_properties(audio.goldfish
    PROPERTIES EXCLUDE_FROM_ALL 1 EXCLUDE_FROM_DEFAULT_BUILD 1)

=== external/CMakeLists.txt ===
add_subdirectory(process-cpp-minimal)
add_subdirectory(android-emugl)
add_subdirectory(xdg)
add_subdirectory(backward-cpp)

set(BUILD_TESTING OFF)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error")
add_subdirectory(cpu_features)
include(ExternalProject)
ExternalProject_Add(sdbus-cpp
  PREFIX sdbus-cpp
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/sdbus-cpp"
  INSTALL_COMMAND ""
  CMAKE_CACHE_ARGS
        -DBUILD_CODE_GEN:BOOL=ON
        -DBUILD_SHARED_LIBS:BOOL=OFF
)

=== src/CMakeLists.txt ===
include_directories(
  ${Boost_INCLUDE_DIRS}
  ${MIRCLIENT_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
  ${SDL2_INCLUDE_DIRS}
  ${SDL2_IMAGE_INCLUDE_DIRS}
  ${PROPERTIES_CPP_INCLUDE_DIRS}
  ${LXC_INCLUDE_DIRS}
  ${MIRCLIENT_INCLUDE_DIRS}
  ${LIBSYSTEMD_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/external
  ${CMAKE_SOURCE_DIR}/external/process-cpp-minimal/include
  ${CMAKE_SOURCE_DIR}/external/android-emugl/shared
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/include
  ${CMAKE_SOURCE_DIR}/external/android-emugl/shared/OpenglCodecCommon
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include/libOpenglRender
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/GLESv1_dec
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/GLESv1_dec
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/GLESv2_dec
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/GLESv2_dec
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/renderControl_dec
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/renderControl_dec
  ${CMAKE_SOURCE_DIR}/external/cpu_features/include
  ${CMAKE_SOURCE_DIR}/external/sdbus-cpp/include
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBINDERFS_PATH=\"\\\"${BINDERFS_PATH}\\\"\"")

protobuf_generate_cpp(
    GENERATED_PROTOBUF_RPC_SRCS GENERATED_PROTOBUF_RPC_HDRS
    anbox/protobuf/anbox_rpc.proto)

protobuf_generate_cpp(
    GENERATED_PROTOBUF_BRIDGE_SRCS GENERATED_PROTOBUF_BRIDGE_HDRS
    anbox/protobuf/anbox_bridge.proto)

protobuf_generate_cpp(
    GENERATED_PROTOBUF_CONTAINER_SRCS GENERATED_PROTOBUF_CONTAINER_HDRS
    anbox/protobuf/anbox_container.proto)


add_library(anbox-protobuf
    STATIC
    ${GENERATED_PROTOBUF_BRIDGE_SRCS}
    ${GENERATED_PROTOBUF_BRIDGE_HDRS}
    ${GENERATED_PROTOBUF_RPC_SRCS}
    ${GENERATED_PROTOBUF_RPC_HDRS}
    ${GENERATED_PROTOBUF_CONTAINER_SRCS}
    ${GENERATED_PROTOBUF_CONTAINER_HDRS}
    anbox/protobuf/anbox_rpc.proto
    anbox/protobuf/anbox_bridge.proto
    anbox/protobuf/anbox_container.proto
    anbox/protobuf/google_protobuf_guard.cpp)
target_link_libraries(anbox-protobuf
    ${PROTOBUF_LITE_LIBRARIES})

set(XML2CPP ${CMAKE_BINARY_DIR}/external/sdbus-cpp/src/sdbus-cpp-build/tools/sdbus-c++-xml2cpp)

macro(DBusServer BaseName)
    add_custom_command(
        COMMAND ${XML2CPP} --adaptor=${CMAKE_CURRENT_BINARY_DIR}/${BaseName}_server_glue.h ${CMAKE_CURRENT_SOURCE_DIR}/anbox/dbus/${BaseName}.xml
        DEPENDS anbox/dbus/${BaseName}.xml
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${BaseName}_server_glue.h
        COMMENT "Generating server code for DBUS (${BaseName})"
    )
    list(APPEND DBUS_GENERATED "${CMAKE_CURRENT_BINARY_DIR}/${BaseName}_server_glue.h")
endmacro()

macro(DBusClient BaseName)
    add_custom_command(
        COMMAND ${XML2CPP} --proxy=${CMAKE_CURRENT_BINARY_DIR}/${BaseName}_client_glue.h ${CMAKE_CURRENT_SOURCE_DIR}/anbox/dbus/${BaseName}.xml
        DEPENDS anbox/dbus/${BaseName}.xml
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${BaseName}_client_glue.h
        COMMENT "Generating client code for DBUS (${BaseName})"
    )
    list(APPEND DBUS_GENERATED "${CMAKE_CURRENT_BINARY_DIR}/${BaseName}_client_glue.h")
endmacro()

set(DBUS_GENERATED)

DBusServer(application_manager)
DBusClient(application_manager)
DBusServer(sensors)
DBusServer(gps)

set(SOURCES
    anbox/android/intent.cpp
    anbox/android/intent.h
    anbox/android/ip_config_builder.cpp
    anbox/android/ip_config_builder.h

    anbox/application/database.cpp
    anbox/application/database.h
    anbox/application/launcher_storage.cpp
    anbox/application/launcher_storage.h
    anbox/application/manager.h
    anbox/application/sensor_type.cpp
    anbox/application/sensor_type.h

    anbox/audio/client_info.h
    anbox/audio/server.cpp
    anbox/audio/server.h
    anbox/audio/sink.h
    anbox/audio/source.h

    anbox/bridge/android_api_stub.cpp
    anbox/bridge/android_api_stub.h
    anbox/bridge/platform_api_skeleton.cpp
    anbox/bridge/platform_api_skeleton.h
    anbox/bridge/platform_message_processor.cpp
    anbox/bridge/platform_message_processor.h

    anbox/build/config.h
    anbox/build/config.h.in

    anbox/cmds/container_manager.cpp
    anbox/cmds/container_manager.h
    anbox/cmds/launch.cpp
    anbox/cmds/launch.h
    anbox/cmds/session_manager.cpp
    anbox/cmds/session_manager.h
    anbox/cmds/system_info.cpp
    anbox/cmds/system_info.h
    anbox/cmds/version.cpp
    anbox/cmds/version.h
    anbox/cmds/wait_ready.cpp
    anbox/cmds/wait_ready.h
    anbox/cmds/check_features.cpp
    anbox/cmds/check_features.h

    anbox/common/binary_writer.cpp
    anbox/common/binary_writer.h
    anbox/common/dispatcher.cpp
    anbox/common/dispatcher.h
    anbox/common/fd.cpp
    anbox/common/fd.h
    anbox/common/fd_sets.h
    anbox/common/loop_device_allocator.cpp
    anbox/common/loop_device_allocator.h
    anbox/common/loop_device.cpp
    anbox/common/loop_device.h
    anbox/common/message_channel.cpp
    anbox/common/message_channel.h
    anbox/common/mount_entry.cpp
    anbox/common/mount_entry.h
    anbox/common/scope_ptr.h
    anbox/common/small_vector.h
    anbox/common/type_traits.h
    anbox/common/variable_length_array.h
    anbox/common/wait_handle.cpp
    anbox/common/wait_handle.h
    anbox/common/binderfs.h
    anbox/common/binder_device.cpp
    anbox/common/binder_device.h
    anbox/common/binder_device_allocator.cpp
    anbox/common/binder_device_allocator.h

    anbox/container/client.cpp
    anbox/container/client.h
    anbox/container/configuration.h
    anbox/container/container.cpp
    anbox/container/container.h
    anbox/container/lxc_container.cpp
    anbox/container/lxc_container.h
    anbox/container/management_api_message_processor.cpp
    anbox/container/management_api_message_processor.h
    anbox/container/management_api_skeleton.cpp
    anbox/container/management_api_skeleton.h
    anbox/container/management_api_stub.cpp
    anbox/container/management_api_stub.h
    anbox/container/service.cpp
    anbox/container/service.h

    anbox/dbus/bus.cpp
    anbox/dbus/bus.h
    anbox/dbus/interface.h
    ${DBUS_GENERATED}
    anbox/dbus/application_manager_server.cpp
    anbox/dbus/application_manager_server.h
    anbox/dbus/application_manager_client.cpp
    anbox/dbus/application_manager_client.h
    anbox/dbus/sensors_server.cpp
    anbox/dbus/sensors_server.h
    anbox/dbus/gps_server.cpp
    anbox/dbus/gps_server.h

    anbox/graphics/buffered_io_stream.cpp
    anbox/graphics/buffered_io_stream.h
    anbox/graphics/buffer_queue.cpp
    anbox/graphics/buffer_queue.h
    anbox/graphics/density.cpp
    anbox/graphics/density.h
    anbox/graphics/gl_extensions.h
    anbox/graphics/gl_renderer_server.cpp
    anbox/graphics/gl_renderer_server.h
    anbox/graphics/layer_composer.cpp
    anbox/graphics/layer_composer.h
    anbox/graphics/multi_window_composer_strategy.cpp
    anbox/graphics/multi_window_composer_strategy.h
    anbox/graphics/opengles_message_processor.cpp
    anbox/graphics/opengles_message_processor.h
    anbox/graphics/primitives.h
    anbox/graphics/program_family.cpp
    anbox/graphics/program_family.h
    anbox/graphics/rect.cpp
    anbox/graphics/rect.h
    anbox/graphics/renderer.h
    anbox/graphics/single_window_composer_strategy.cpp
    anbox/graphics/single_window_composer_strategy.h

    anbox/graphics/emugl/ColorBuffer.cpp
    anbox/graphics/emugl/ColorBuffer.h
    anbox/graphics/emugl/DispatchTables.h
    anbox/graphics/emugl/DisplayManager.cpp
    anbox/graphics/emugl/DisplayManager.h
    anbox/graphics/emugl/ReadBuffer.cpp
    anbox/graphics/emugl/ReadBuffer.h
    anbox/graphics/emugl/Renderable.cpp
    anbox/graphics/emugl/Renderable.h
    anbox/graphics/emugl/RenderApi.cpp
    anbox/graphics/emugl/RenderApi.h
    anbox/graphics/emugl/RenderContext.cpp
    anbox/graphics/emugl/RenderContext.h
    anbox/graphics/emugl/RenderControl.cpp
    anbox/graphics/emugl/RenderControl.h
    anbox/graphics/emugl/RendererConfig.cpp
    anbox/graphics/emugl/RendererConfig.h
    anbox/graphics/emugl/Renderer.cpp
    anbox/graphics/emugl/Renderer.h
    anbox/graphics/emugl/RenderThread.cpp
    anbox/graphics/emugl/RenderThread.h
    anbox/graphics/emugl/RenderThreadInfo.cpp
    anbox/graphics/emugl/RenderThreadInfo.h
    anbox/graphics/emugl/TextureDraw.cpp
    anbox/graphics/emugl/TextureDraw.h
    anbox/graphics/emugl/TextureResize.cpp
    anbox/graphics/emugl/TextureResize.h
    anbox/graphics/emugl/TimeUtils.cpp
    anbox/graphics/emugl/TimeUtils.h
    anbox/graphics/emugl/WindowSurface.cpp
    anbox/graphics/emugl/WindowSurface.h

    anbox/input/device.cpp
    anbox/input/device.h
    anbox/input/manager.cpp
    anbox/input/manager.h

    anbox/network/base_socket_messenger.cpp
    anbox/network/base_socket_messenger.h
    anbox/network/connection_context.cpp
    anbox/network/connection_context.h
    anbox/network/connection_creator.cpp
    anbox/network/connection_creator.h
    anbox/network/connections.h
    anbox/network/connector.h
    anbox/network/credentials.cpp
    anbox/network/credentials.h
    anbox/network/delegate_connection_creator.h
    anbox/network/delegate_message_processor.cpp
    anbox/network/delegate_message_processor.h
    anbox/network/fd_socket_transmission.cpp
    anbox/network/fd_socket_transmission.h
    anbox/network/local_socket_messenger.cpp
    anbox/network/local_socket_messenger.h
    anbox/network/message_processor.h
    anbox/network/message_receiver.h
    anbox/network/message_sender.h
    anbox/network/published_socket_connector.cpp
    anbox/network/published_socket_connector.h
    anbox/network/socket_connection.cpp
    anbox/network/socket_connection.h
    anbox/network/socket_helper.cpp
    anbox/network/socket_helper.h
    anbox/network/socket_messenger.cpp
    anbox/network/socket_messenger.h
    anbox/network/tcp_socket_connector.cpp
    anbox/network/tcp_socket_connector.h
    anbox/network/tcp_socket_messenger.cpp
    anbox/network/tcp_socket_messenger.h

    anbox/platform/base_platform.cpp
    anbox/platform/base_platform.h
    anbox/platform/null/platform.cpp
    anbox/platform/null/platform.h
    anbox/platform/sdl/audio_sink.cpp
    anbox/platform/sdl/audio_sink.h
    anbox/platform/sdl/keycode_converter.cpp
    anbox/platform/sdl/keycode_converter.h
    anbox/platform/sdl/platform.cpp
    anbox/platform/sdl/platform.h
    anbox/platform/sdl/sdl_wrapper.h
    anbox/platform/sdl/window.cpp
    anbox/platform/sdl/window.h

    anbox/protobuf/anbox_bridge.proto
    anbox/protobuf/anbox_container.proto
    anbox/protobuf/anbox_rpc.proto
    anbox/protobuf/google_protobuf_guard.cpp

    anbox/qemu/adb_message_processor.cpp
    anbox/qemu/adb_message_processor.h
    anbox/qemu/at_parser.cpp
    anbox/qemu/at_parser.h
    anbox/qemu/bootanimation_message_processor.cpp
    anbox/qemu/bootanimation_message_processor.h
    anbox/qemu/boot_properties_message_processor.cpp
    anbox/qemu/boot_properties_message_processor.h
    anbox/qemu/camera_message_processor.cpp
    anbox/qemu/camera_message_processor.h
    anbox/qemu/fingerprint_message_processor.cpp
    anbox/qemu/fingerprint_message_processor.h
    anbox/qemu/gps_message_processor.cpp
    anbox/qemu/gps_message_processor.h
    anbox/qemu/gsm_message_processor.cpp
    anbox/qemu/gsm_message_processor.h
    anbox/qemu/hwcontrol_message_processor.cpp
    anbox/qemu/hwcontrol_message_processor.h
    anbox/qemu/null_message_processor.cpp
    anbox/qemu/null_message_processor.h
    anbox/qemu/pipe_connection_creator.cpp
    anbox/qemu/pipe_connection_creator.h
    anbox/qemu/qemud_message_processor.cpp
    anbox/qemu/qemud_message_processor.h
    anbox/qemu/sensors_message_processor.cpp
    anbox/qemu/sensors_message_processor.h

    anbox/rpc/channel.cpp
    anbox/rpc/channel.h
    anbox/rpc/connection_creator.cpp

=== tests/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")

include_directories(
  ${Boost_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include
  ${CMAKE_SOURCE_DIR}/src
)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../external/sdbus-cpp/src/sdbus-cpp-build/)

macro(ANBOX_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src}
  )

  target_link_libraries(
    ${test_name}

    anbox-core

    ${GMOCK_LIBRARIES}
    ${GTEST_BOTH_LIBRARIES}

    ${ARGN}

    ${Boost_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
  )

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)
endmacro(ANBOX_ADD_TEST)

add_subdirectory(anbox)

=== external/process-cpp-minimal/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

cmake_minimum_required(VERSION 2.8)

project(process-cpp)

find_package(Boost COMPONENTS iostreams system REQUIRED)
find_package(Threads REQUIRED)

include(GNUInstallDirs)

set(PROCESS_CPP_VERSION_MAJOR 2)
set(PROCESS_CPP_VERSION_MINOR 0)
set(PROCESS_CPP_VERSION_PATCH 0)

include(CTest)

include_directories(
  include/
  src/
  external/process-cpp-minimal
  ${Boost_INCLUDE_DIRS}
)

add_subdirectory(src)

=== tests/anbox/CMakeLists.txt ===
add_subdirectory(android)
add_subdirectory(application)
add_subdirectory(support)
add_subdirectory(common)
add_subdirectory(graphics)
add_subdirectory(container)

=== external/process-cpp-minimal/src/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>
add_library(
  process-cpp

  STATIC
  
  core/posix/backtrace.h
  core/posix/backtrace.cpp

  core/posix/child_process.cpp
  core/posix/exec.cpp
  core/posix/fork.cpp
  core/posix/process.cpp
  core/posix/process_group.cpp
  core/posix/signal.cpp
  core/posix/signalable.cpp
  core/posix/standard_stream.cpp
  core/posix/wait.cpp
  core/posix/this_process.cpp

  core/posix/linux/proc/process/oom_adj.cpp
  core/posix/linux/proc/process/oom_score.cpp
  core/posix/linux/proc/process/oom_score_adj.cpp
  core/posix/linux/proc/process/stat.cpp

  core/testing/cross_process_sync.cpp
  core/testing/fork_and_run.cpp
)

target_link_libraries(
  process-cpp

  ${Boost_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

=== tests/anbox/android/CMakeLists.txt ===
ANBOX_ADD_TEST(intent_tests intent_tests.cpp)

=== tests/anbox/container/CMakeLists.txt ===
ANBOX_ADD_TEST(lxc_container_tests lxc_container_tests.cpp)

=== tests/anbox/support/CMakeLists.txt ===
ANBOX_ADD_TEST(at_parser_tests at_parser_tests.cpp)

=== external/android-emugl/host/tools/CMakeLists.txt ===
add_subdirectory(emugen)

=== debian/changelog ===
anbox (0.0~git20210106-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add instruction to restart anbox-container-manager.service (Closes: #973487)
  * Add libcpu-features-dev libsdbus-c++-dev to Build-Depends
  * Install anbox xdg menu (Closes: #948618)
  * Update Standards-Version to 4.5.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 11 Jan 2021 11:56:16 +0800

=== debian/control ===
Source: anbox
Section: contrib/utils
Priority: optional
Maintainer: Shengjing Zhu <zhsj@debian.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-log-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libcap-dev,
 libcpu-features-dev,
 libegl1-mesa-dev,
 libgles2-mesa-dev,
 libglm-dev,
 libgmock-dev,
 libproperties-cpp-dev,
 libprotobuf-dev,
 libsdbus-c++-dev (>= 0.8.3-3),
 libsdl2-dev,
 libsdl2-image-dev,
 libsystemd-dev,
 lxc-dev,
 protobuf-compiler,
 python3,
Standards-Version: 4.5.1
Homepage: https://anbox.io
Vcs-Git: https://salsa.debian.org/zhsj/anbox.git
Vcs-Browser: https://salsa.debian.org/zhsj/anbox

Package: anbox
Architecture: amd64 arm64 armhf
Built-Using:
 ${misc:Built-Using},
Depends:
 iptables,
 libegl1,
 libgles2,
 ${misc:Depends},
 ${misc:LxcDepends},
 ${shlibs:Depends},
Recommends:
 dbus-user-session,
Description: Android in a box
 Anbox is a container-based approach to boot a full Android system on a
 regular GNU/Linux system.
 .
 In other words: Anbox will let you run Android on your Linux system
 without the slowness of virtualization.
 .
 Anbox uses Linux namespaces (user, pid, uts, net, mount, ipc) to run a
 full Android system in a container and provide Android applications on any
 GNU/Linux-based platform.
 .
 The Android inside the container has no direct access to any hardware. All
 hardware access is going through the anbox daemon on the host. It reuses
 what Android implemented within the QEMU-based emulator for OpenGL ES
 accelerated rendering. The Android system inside the container uses
 different pipes to communicate with the host system and sends all hardware
 access commands through these.
 .
 This package needs Android kernel modules and rootfs image, see
 /usr/share/doc/anbox/README.Debian for information.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

HEADER_PACKAGES := libproperties-cpp-dev
EXTRA_SUBSTVARS := \
	-Vmisc:Built-Using="$(shell dpkg-query -Wf '$${source:Package}(=$${Version}),' $(HEADER_PACKAGES))"
LXC_VER := $(shell dpkg-query -Wf '$${Version}' lxc)
LXC_EPOCH := $(shell echo $(LXC_VER) | sed -e 's/[^:]*$$//')
LXC_MAJOR_VER := $(shell echo $(LXC_VER) | sed -e 's/\..*$$//'|sed -e 's/^[0-9]*://')

ifeq ($(LXC_MAJOR_VER), 2)
	EXTRA_SUBSTVARS += \
		-Vmisc:LxcDepends="lxc"
else
	EXTRA_SUBSTVARS += \
		-Vmisc:LxcDepends="lxc (>= $(LXC_EPOCH)3.0.0)"
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_TOUCH_INPUT=ON \
		-DENABLE_WAYLAND=OFF \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DANBOX_VERSION=$(DEB_VERSION) \
		-DANBOX_VERSION_SUFFIX=$(DEB_VENDOR)

override_dh_auto_install:
	dh_auto_install
	cp snap/gui/icon.png debian/anbox.png

override_dh_gencontrol:
	dh_gencontrol -- $(EXTRA_SUBSTVARS)

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0.0~git%cd" \
https://github.com/anbox/anbox \
HEAD

## anbox 0.0~git20211020

=== external/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 set(BUILD_TESTING OFF)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error")
-add_subdirectory(cpu_features)
+add_subdirectory(cpu_features EXCLUDE_FROM_ALL)
 include(ExternalProject)
 ExternalProject_Add(sdbus-cpp
   PREFIX sdbus-cpp

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -204,6 +204,8 @@
     anbox/graphics/multi_window_composer_strategy.h
     anbox/graphics/opengles_message_processor.cpp
     anbox/graphics/opengles_message_processor.h
+    anbox/graphics/opengles_socket_connection.cpp
+    anbox/graphics/opengles_socket_connection.h
     anbox/graphics/primitives.h
     anbox/graphics/program_family.cpp
     anbox/graphics/program_family.h
@@ -327,8 +329,3 @@
     anbox/qemu/qemud_message_processor.cpp
     anbox/qemu/qemud_message_processor.h
     anbox/qemu/sensors_message_processor.cpp
-    anbox/qemu/sensors_message_processor.h
-
-    anbox/rpc/channel.cpp
-    anbox/rpc/channel.h
-    anbox/rpc/connection_creator.cpp

=== external/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)
project(backward CXX)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

# Anbox: allow old-style cast, unknown pragmas
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=old-style-cast -Wno-error=unknown-pragmas -Wno-error=switch-default")

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

###############################################################################
# TESTS
###############################################################################

if(BACKWARD_TESTS)
	enable_testing()

	add_library(test_main SHARED test/_test_main.cpp)

	macro(backward_add_test src)
		get_filename_component(name ${src} NAME_WE)
		set(test_name "test_${name}")

		add_executable(${test_name} ${src} ${ARGN})

		target_link_libraries(${test_name} PRIVATE Backward::Backward test_main)

		add_test(NAME ${name} COMMAND ${test_name})
	endmacro()

	# Tests without backward.cpp
	set(TESTS
		test
		stacktrace
		rectrace
		select_signals
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp)
	endforeach()

	# Tests with backward.cpp
	set(TESTS
		suicide
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp ${BACKWARD_ENABLE})
	endforeach()
endif()

install(
    FILES "backward.hpp"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)
install(
    FILES "BackwardConfig.cmake"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/backward
)

=== android/opengl/shared/OpenglCodecCommon/Makefile ===

ROOT=../..

include $(ROOT)/make/commondefs

CXXFILES = TcpStream.cpp GLClientState.cpp glUtils.cpp
CXXINCS += -I$(ROOT)/libs/GLESv1 -I$(ROOT)/include

LIBRARY_NAME = libcodecCommon.a

include $(COMMONRULES)

=== external/android-emugl/host/libs/libOpenGLESDispatch/CMakeLists.txt ===
PREPEND(SOURCES ${CMAKE_CURRENT_LIST_DIR}/
    EGLDispatch.cpp
    GLESv2Dispatch.cpp
    GLESv1Dispatch.cpp)

add_library(OpenGLESDispatch STATIC ${SOURCES} ${GLHEADERS_GENERATED_SOURCES})
target_link_libraries(OpenGLESDispatch
    emugl_common
    GLESv2_dec
    GLESv1_dec)

=== debian/changelog ===
anbox (0.0~git20211020-3) unstable; urgency=medium

  * Use debhelper to install systemd service properly (Closes: #1010562)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 04 May 2022 20:32:15 +0800

anbox (0.0~git20211020-2) unstable; urgency=medium

  * Rebuild with sdbus-cpp 1.1.0

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 10 Feb 2022 10:39:26 +0800

anbox (0.0~git20211020-1) unstable; urgency=medium

  * New upstream snapshot.
    Fix build with GCC 11. (Closes: #999624)
  * Install anbox dbus service

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 14 Nov 2021 22:47:19 +0800

anbox (0.0~git20210625-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add libsdbus-c++-bin to Build-Depends
  * Backport patch for lxc >= 4.0.9
  * Update Standards-Version to 4.6.0 (no changes)
  * Add cmake-extras to Build-Depends
  * Move systemd service to /usr/lib/systemd/system/
  * Fix desktop file name in menu

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 01 Sep 2021 03:43:32 +0800

=== debian/rules ===
--- 
+++ 
@@ -36,3 +36,9 @@
 
 override_dh_gencontrol:
 	dh_gencontrol -- $(EXTRA_SUBSTVARS)
+
+override_dh_installsystemd:
+	dh_installsystemd --name=anbox-container-manager
+
+override_dh_installsystemduser:
+	dh_installsystemduser --name=anbox-session-manager
